aboutsummaryrefslogtreecommitdiff
path: root/tests/functional/function-trace.sh
diff options
context:
space:
mode:
Diffstat (limited to 'tests/functional/function-trace.sh')
-rwxr-xr-xtests/functional/function-trace.sh67
1 files changed, 67 insertions, 0 deletions
diff --git a/tests/functional/function-trace.sh b/tests/functional/function-trace.sh
new file mode 100755
index 000000000..bd804bf18
--- /dev/null
+++ b/tests/functional/function-trace.sh
@@ -0,0 +1,67 @@
+source common.sh
+
+set +x
+
+expect_trace() {
+ expr="$1"
+ expect="$2"
+ actual=$(
+ nix-instantiate \
+ --trace-function-calls \
+ --expr "$expr" 2>&1 \
+ | grep "function-trace" \
+ | sed -e 's/ [0-9]*$//' \
+ || true
+ )
+
+ echo -n "Tracing expression '$expr'"
+ msg=$(diff -swB \
+ <(echo "$expect") \
+ <(echo "$actual")
+ ) && result=0 || result=$?
+ if [ $result -eq 0 ]; then
+ echo " ok."
+ else
+ echo " failed. difference:"
+ echo "$msg"
+ return $result
+ fi
+}
+
+# failure inside a tryEval
+expect_trace 'builtins.tryEval (throw "example")' "
+function-trace entered «string»:1:1 at
+function-trace entered «string»:1:19 at
+function-trace exited «string»:1:19 at
+function-trace exited «string»:1:1 at
+"
+
+# Missing argument to a formal function
+expect_trace '({ x }: x) { }' "
+function-trace entered «string»:1:1 at
+function-trace exited «string»:1:1 at
+"
+
+# Too many arguments to a formal function
+expect_trace '({ x }: x) { x = "x"; y = "y"; }' "
+function-trace entered «string»:1:1 at
+function-trace exited «string»:1:1 at
+"
+
+# Not enough arguments to a lambda
+expect_trace '(x: y: x + y) 1' "
+function-trace entered «string»:1:1 at
+function-trace exited «string»:1:1 at
+"
+
+# Too many arguments to a lambda
+expect_trace '(x: x) 1 2' "
+function-trace entered «string»:1:1 at
+function-trace exited «string»:1:1 at
+"
+
+# Not a function
+expect_trace '1 2' "
+function-trace entered «string»:1:1 at
+function-trace exited «string»:1:1 at
+"